// About.java
/* A Java class for
 * LineImpedance.java
 * Electromagnetic Transmission Line Applet
 * Applet without Smith Chart - Prepared by Umberto Ravaioli 
 * for 6th edition of Fundamentals of Applied Electromagnetics Book
 * May 2009 - All Rights Reserved
 */   


import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.*;
import java.net.URL;
import java.text.*;
import java.util.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.jar.Attributes;


public class Instructions extends Panel {
    
    private static final Color bgcolor = new Color(255,255,245);
    //private static final Color bgcolor = Color.white;
    
    public TextField epsilon;
    private Paint paint;
    
    private Image im;
    private Graphics buf;

    //Mod1State state;
    public Button bupdate;
  
    public Instructions(){
	super();
        //this.state = state;
	setLayout(null);
	setBackground(bgcolor);
	bupdate = new Button("CLOSE");
        bupdate.setBackground(new Color(240,240,255));
	add(bupdate);
        //int buttonx = 410;
        //int buttony = 440;
        int buttonx = 455;
        int buttony = 265;
        int buttonwide = 70;
        int buttonheight = 27;
        
        bupdate.setBounds(buttonx,buttony,buttonwide,buttonheight);	
        Panel ps7 = new Panel();
	    ps7.setBackground(Color.lightGray);
	    add(ps7);
	    ps7.setBounds(buttonx-1,buttony-1,buttonwide+2,buttonheight+2);
	    
	Panel ps8 = new Panel();
	    ps8.setBackground(Color.black);
	    add(ps8);
	    ps8.setBounds(buttonx-2,buttony-2,buttonwide+4,buttonheight+4);	
    }
    
    public void paint(Graphics g){
            
	    if(im == null){
		im = createImage(getSize().width,getSize().height);
		buf = im.getGraphics();
		drawCanvas(buf);
	    }
	    else{
		drawCanvas(buf);
	    }
	    g.drawImage(im,0,0,null);
    }
	
	//Addition to reduce flicker new routine
    public void update(Graphics g){		// added to avoid clearing
            paint(g);
    }
    
    public void clear(){
	    this.getGraphics().clearRect(0,0,getSize().width,getSize().height);
	    repaint();
    }
    
    public void drawCanvas(Graphics g){
        FontMetrics fm;
        Graphics2D g2d = (Graphics2D)g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON);        
        g.clearRect(0,0,getSize().width-1,getSize().height-1);

        //g.setFont(font_one);
        //fm = g.getFontMetrics();

        //boolean saveOldFlag = MaestroG.useBiggerFont;
        //MaestroG.useBiggerFont = false;
        
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,16f));
        g.setFont(new Font("SanSerif",Font.BOLD,16));
        
        g.drawString("Instructions", 20,25);
        
        //g.setFont(state.ttfFont.deriveFont(14f));
        //g.setFont(new Font("SanSerif",Font.PLAIN,14));
        //g.drawString("This module can accomodate linearly polarized plane "+
        //            "waves in both lossy and lossless media.",15,50);
        
        g.setFont(new Font("SanSerif",Font.PLAIN,14));

        /*
        String s = "This module displays the far-field patterns of "+
            STR.BOLD+"E"+STR.ENDBOLD+" and "+
            STR.BOLD+"S"+STR.ENDBOLD+STR.SUB+"av"+STR.ENDSUB+
            " in elevation (\u03b8-plane) ";
        int nextX = STR.displayString(s,g,200,15);
        s = "  and azimuth ("+
            STR.PHIFONT+"\u03c6"+STR.ENDPHIFONT+"-plane) "+
            "for two linear dipoles oriented along the z-direction.";
        nextX = STR.displayString(s,g,200,35);
        */
        String s = "This module displays the far-field patterns of "+
            STR.BOLD+"E"+STR.ENDBOLD+" and "+
            STR.BOLD+"S"+STR.ENDBOLD+STR.SUB+"av"+STR.ENDSUB;
        int nextX = STR.displayString(s,g,200,20);
        s = " in elevation (\u03b8-plane) and azimuth ("+"\u03c6"+"-plane)";
            //STR.PHIFONT+"\u03c6"+STR.ENDPHIFONT+"-plane)";
        nextX = STR.displayString(s,g,200,40);
        s = " for two linear dipoles oriented along the z-direction.";
        nextX = STR.displayString(s,g,200,60);



        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));

        //g.drawString("Input", 15,50);
        g.drawString("Input", 15,80);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        int deltaY = 20;
        //INPUT
        s = "\u2022 Current amplitudes and lengths of dipoles A and B";
        nextX = STR.displayString(s,g,15,100);
        s = "\u2022 Distance between dipoles A and B";
        nextX = STR.displayString(s,g,15,100+deltaY);
        s = "\u2022 Phase of dipole B relative to that of A";
        nextX = STR.displayString(s,g,15,100+2*deltaY);
       //OUTPUT
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));
        int newY = 100+3*deltaY+10;
        g.drawString("Displayed Information", 15,newY);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        newY += 20;
        s = "\u2022 Radiation patterns";
        nextX = STR.displayString(s,g,15,newY);
        s = "\u2022 Total radiated power";
        nextX = STR.displayString(s,g,15,newY+deltaY);
        s = "\u2022 Directivity";
        nextX = STR.displayString(s,g,15,newY+2*deltaY);
        drawCopyRight(g);

        //MaestroG.useBiggerFont = saveOldFlag;

    }


    public void drawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 70;
        int startingX = 0;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        fm = g.getFontMetrics();
        g.drawString("Applet Design: Umberto Ravaioli",
                     startingX+15,startingY+deltaY);
        
        //MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
        //                       g,14,startingX,startingY+2*deltaY);
        String s = "Interactive Java"+STR.SUP+"TM"+STR.ENDSUP+
            " platform:  www.amanogawa.com";
        int nextX = STR.displayString(s,g,startingX+15,startingY+2*deltaY);
        int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        lineLength+= 10;

        //g.setFont(state.ttfFont.deriveFont(14f));
        g.drawString("All Rights Reserved",startingX+15,startingY+3*deltaY);
        g.drawLine(startingX,startingY+5,
                   startingX+15+lineLength+10,startingY+5);
        g.drawLine(startingX+15+lineLength+10,startingY+5,
                   startingX+15+lineLength+10,startingY+4*deltaY);
    }

//----------------------------------------------------------------------------------------    
}//End
    

